Package org.springframework.jdbc.support

# Class GeneratedKeyHolder

java.lang.Object
org.springframework.jdbc.support.GeneratedKeyHolder

All Implemented Interfaces:
  `KeyHolder`

public class GeneratedKeyHolder extends Object implements KeyHolder
The standard implementation of the `KeyHolder` interface, to be used for holding auto-generated keys (as potentially returned by JDBC insert statements).

Create an instance of this class for each insert operation, and pass it to the corresponding `JdbcTemplate` or `SqlUpdate` methods.

Since:
  1.1
Author:
  Thomas Risberg, Juergen Hoeller, Slawomir Dymitrow

## Constructor Summary

Constructors
Constructor
Description
`GeneratedKeyHolder()`
Create a new GeneratedKeyHolder with a default list.
`GeneratedKeyHolder(List<Map<String,Object>> keyList)`
Create a new GeneratedKeyHolder with a given list.

## Method Summary

Modifier and Type
Method
Description
`Number`
`getKey()`
Retrieve the first item from the first map, assuming that there is just one item and just one map, and that the item is a number.
`<T> T`
`getKeyAs(Class<T> keyType)`
Retrieve the first item from the first map, assuming that there is just one item and just one map, and that the item is an instance of specified type.
`List<Map<String,Object>>`
`getKeyList()`
Return a reference to the List that contains the keys.
`Map<String,Object>`
`getKeys()`
Retrieve the first map of keys.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### GeneratedKeyHolder

public GeneratedKeyHolder()
Create a new GeneratedKeyHolder with a default list.

### GeneratedKeyHolder

public GeneratedKeyHolder(List<Map<String,Object>> keyList)
Create a new GeneratedKeyHolder with a given list.

Parameters:
  `keyList` - a list to hold maps of keys

## Method Details

### getKey

@Nullable public Number getKey() throws org.springframework.dao.InvalidDataAccessApiUsageException, org.springframework.dao.DataRetrievalFailureException
Description copied from interface: `KeyHolder`
Retrieve the first item from the first map, assuming that there is just one item and just one map, and that the item is a number. This is the typical case: a single, numeric generated key.

Keys are held in a List of Maps, where each item in the list represents the keys for each row. If there are multiple columns, then the Map will have multiple entries as well. If this method encounters multiple entries in either the map or the list meaning that multiple keys were returned, then an InvalidDataAccessApiUsageException is thrown.

Specified by:
  `getKey` in interface `KeyHolder`
Returns:
  the generated key as a number
Throws:
  `org.springframework.dao.InvalidDataAccessApiUsageException` - if multiple keys are encountered
  `org.springframework.dao.DataRetrievalFailureException`
See Also:
  - `KeyHolder.getKeyAs(Class)`

### getKeyAs

@Nullable public <T> T getKeyAs(Class<T> keyType) throws org.springframework.dao.InvalidDataAccessApiUsageException, org.springframework.dao.DataRetrievalFailureException
Description copied from interface: `KeyHolder`
Retrieve the first item from the first map, assuming that there is just one item and just one map, and that the item is an instance of specified type. This is a common case: a single generated key of the specified type.

Keys are held in a List of Maps, where each item in the list represents the keys for each row. If there are multiple columns, then the Map will have multiple entries as well. If this method encounters multiple entries in either the map or the list meaning that multiple keys were returned, then an InvalidDataAccessApiUsageException is thrown.

Specified by:
  `getKeyAs` in interface `KeyHolder`
Parameters:
  `keyType` - the type of the auto-generated key
Returns:
  the generated key as an instance of specified type
Throws:
  `org.springframework.dao.InvalidDataAccessApiUsageException` - if multiple keys are encountered
  `org.springframework.dao.DataRetrievalFailureException`
See Also:
  - `KeyHolder.getKey()`

### getKeys

@Nullable public Map<String,Object> getKeys() throws org.springframework.dao.InvalidDataAccessApiUsageException
Description copied from interface: `KeyHolder`
Retrieve the first map of keys.

If there are multiple entries in the list (meaning that multiple rows had keys returned), then an InvalidDataAccessApiUsageException is thrown.

Specified by:
  `getKeys` in interface `KeyHolder`
Returns:
  the Map of generated keys for a single row
Throws:
  `org.springframework.dao.InvalidDataAccessApiUsageException` - if keys for multiple rows are encountered

### getKeyList

public List<Map<String,Object>> getKeyList()
Description copied from interface: `KeyHolder`
Return a reference to the List that contains the keys.

Can be used for extracting keys for multiple rows (an unusual case), and also for adding new maps of keys.

Specified by:
  `getKeyList` in interface `KeyHolder`
Returns:
  the List for the generated keys, with each entry representing an individual row through a Map of column names and key values